<%

Function FormatHex(n,l)
    Dim s
    s = Hex(n)
    While Len(s) < l
        s = "0" & s
    Wend
    FormatHex = s
End Function
    
Sub DumpBin(bin,size)    
    Dim I, J
    Dim RequestBin
    Response.Write FormatHex(0,8) & "    "
        
    RequestBin=bin
    For i = 1 To size
        j = (i - 1) Mod 16
        c = MidB(RequestBin,i,1)
        ln = FormatHex(AscB(c),2) & " "
        Response.Write ln
        if AscB(c) < 32 Or AscB(c) > 255 Then str = str & "." Else str = str & Chr(AscB(c))
        
        If j >= 15 Then
            Response.Write "    " & Server.HTMLEncode(str)
            Response.Write vbCrLf
            str = ""
            If i Mod 256 = 0 Then Response.Write vbCrLf 
            Response.Write FormatHex(i,8) & "    "
        End If
    Next
End Sub    


Class CUpload
    Public postStream
    Public Post
    Private sf
    
    ' Constructors
    Private Sub Class_Initialize()
        Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
        Set postStream = sf.CreateMemoryStream
        postStream.WriteBin Request.BinaryRead(Request.TotalBytes)
        postStream.Pos = 0
        postStream.unicodeText = False
        Set Post = Server.CreateObject("newObjects.utilctls.VarDictionary")
        Post.itemsAssignmentAllowed = True
        Post.Missing = Empty
        BuildUploadRequest
    End Sub
    Private Sub Class_Terminate()
        Set postStream = Nothing
        Set sf = Nothing
        Set Post = Nothing
    End Sub
    
    ' Private mambers
    Private Function MaxNum(a,b)
        If a >= b Then MaxNum = a Else MaxNum = b
    End Function
    Private Function FindColonThroughQuotes(str,beg)
        Dim qPos, cPos
        Dim pos, qOpened
        
        pos = beg
        qOpened = False

        Do
            If qOpened Then
                qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
                If qPos = 0 Then
                    ' In fact this is an error but we will ignore it anyway
                    ' If you want to be more prcise put here an error raising code
                    FindColonThroughQuotes = Len(str) + 1
                    Exit Function
                Else
                    pos = qPos + 1
                    qOpened = False
                End If
            Else
                qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
                cPos = InStr(pos,str,";")
                If qPos = 0 Then
                    If cPos > 0 Then
                        FindColonThroughQuotes = cPos
                    Else
                        FindColonThroughQuotes = Len(str) + 1
                    End If
                    Exit Function
                End If
                If cPos <= qPos Then
                    If cPos > 0 Then
                        FindColonThroughQuotes = cPos
                    Else
                        FindColonThroughQuotes = Len(str) + 1
                    End If
                    Exit Function
                End If
                
                qOpened = True
                pos = qPos + 1
            End If
        Loop
        
    End Function
    Private Sub ProcessContentType(content,field)
        Dim n
        n = FindColonThroughQuotes(content,1)
        field("ContentType") = Trim(Left(content,n - 1))
    End Sub
    Private Function StripQuotes(str)
        If Left(str,1) = """" Or Left(str,1) = "'" Then
            StripQuotes = Mid(str,2,Len(str) - 2)
        Else
            StripQuotes = str
        End If
    End Function
    Private Sub ProcessContentDisposition(content,field)
        Dim n, cnt, cur, t
        cnt = content
        n = 0
        
        Do 
            n = FindColonThroughQuotes(cnt,1)
            cur = Trim(Left(cnt,n - 1))
            If cur = "" Then Exit Sub
            t = InStr(cur,"=")
            If t > 0 Then
                Select Case UCase(Left(cur,t - 1))
                    Case "NAME"
                        field("Name") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                    Case "FILENAME"
                        field("RawFileName") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                        field("FileName") = sf.GetFileName(field("RawFileName"))
                        field("FileNameExtension") = sf.GetExtensionName(field("RawFileName"))
                        field("IsFile") = True
                End Select
            End If
            cnt = Mid(cnt,n+1)
        Loop
    End Sub
    Private Sub ProcessHeader(line, field)
        Dim headName, n, headContent
        n = InStr(line,":")
        If n = 0 Then Err.Raise 2,"CUpload", "Invalid header: " & line
        headName = Trim(Left(line, n -1))
        headContent = Mid(line,n + 1, Len(line) - n)
        Select Case UCase(headName)
            Case "CONTENT-TYPE"
                ProcessContentType headContent, field
            Case "CONTENT-DISPOSITION"
                ProcessContentDisposition headContent, field
        End Select
    End Sub
    Private Sub BuildUploadRequest()
        ' Determine the boundary (it is the first line)
        Dim boundary, eolSequence, eolLength
        boundary = postStream.ReadText(-3)
        If boundary = "" Then Err.Raise 1, "CUpload", "Incorrect post encoding"
        ' Determine the end-of-line
        eolLength = postStream.Pos - Len(boundary)
        postStream.Pos = Len(boundary)
        eolSequence = postStream.ReadText(eolLength)
        postStream.textLineSeparator = eolSequence
          
        ' Loop through the fields
        Dim line ' The current line
        Dim nextLine ' The next line
        Dim field ' The current field
        Dim coll, temp
        Do
            ' Create a node holder for the element/field
            Set field = Post.CreateNew
            field.firstItemAsRoot = True
            field.Add "Value", Empty
            field("IsFile") = False
            ' Loop through the headers
            line = postStream.ReadText(-1)
            While line <> ""
                ' Read next line
                nextLine = postStream.ReadText(-1)
                ' The headers support hiphenation (not happens with IE but it is possible with other browsers)
                While Left(nextLine,1) = vbTab Or Left(nextLine,1) = " "
                    line = line & nextLine
                    nextLine = postStream.ReadText(-1)
                Wend
                ' Here we have the full line
                ProcessHeader line, field
                line = nextLine
            Wend
            ' Headers ended - the content follows
            ' Find the end
            field("ContentBegin") = postStream.Pos
            field("ContentEnd") = postStream.Find(boundary,2) - Len(boundary) - eolLength
            field("ContentLength") = field("ContentEnd") - field("ContentBegin")
            
            ' Set the value
            
            If field("IsFile") Then
                temp = postStream.Pos
                postStream.Pos = field("ContentBegin")
                field("Value") = postStream.ReadBin(field("ContentLength"))
                postStream.Pos = temp
            Else
                temp = postStream.Pos
                postStream.Pos = field("ContentBegin")
                field("Value") = postStream.ReadText(field("ContentLength"))
                postStream.Pos = temp
            End IF
            
            If IsEmpty(Post(field("Name"))) Then
                Set coll = Post.CreateNew
                coll.firstItemAsRoot = True
                coll.allowUnnamedValues = True
                coll.Add "", field
                Post.Add field("Name"), coll
            Else
                Post(field("Name")).Add "", field
            End If
            
            line = postStream.ReadText(-1)
            If line = "--" Then
                ' This is end of the upload
                Exit Do
            End If            
        Loop
        Set postStream = Nothing
    End Sub
    
    ' Public members
    Public Default Property Get Value
        Set Value = Post
    End Property
End Class
%>